.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 20000

.code
start:
	print "Test for correctness:"
	mov eax, 123456/2		; magic number
	call stack_frame_OFF
	print chr$(9, "oops: esp changes 'inside' an invoke ...")

	mov eax, 123456/2		; magic number
	call stack_frame_ON
	print chr$(9, "correct!")

	print chr$(13, 10, 10, "Timings:", 13, 10)
	
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov eax, 1234578h
		REPEAT 100
			call stack_frame_ON
		ENDM
	counter_end
	print str$(eax), 9, "cycles for 100 * call stack_frame_ON", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov eax, 1234578h
		REPEAT 100
			call stack_frame_OFF
		ENDM
	counter_end
	print str$(eax), 9, "cycles for 100 * call stack_frame_OFF", 13, 10, 10, "Code sizes:", 13, 10, "Frame on: ", 9
	mov eax, stack_frame_ON_END
	sub eax, stack_frame_ON
	print str$(eax), 13, 10, "Frame off: ", 9
	mov eax, stack_frame_OFF_END
	sub eax, stack_frame_OFF
	print str$(eax)

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

nfPush MACRO arg
  .if 1				; the .if 1 does not generate any code but throws ...
	push arg
	MyBase = MyBase + 4
ENDM
nfPop MACRO arg
	pop arg
	MyBase = MyBase - 4
  .endif			; ... an error if there is no corresponding endif
ENDM

nfLocal MACRO args:VARARG
  .if 1
	MyLocEsp = 0
	MyBase = 0
	FOR arg, <args>
	  	@CatStr(<arg>, < equ !<dword ptr [esp+MyBase+>, %MyLocEsp, <]!>>)
		MyLocEsp = MyLocEsp + 4
	ENDM
	@CatStr(<add esp, ->, %MyLocEsp)
ENDM

nfRet MACRO NumRet
	@CatStr(<sub esp, ->, %MyLocEsp)
	ret NumRet		;; nr is optional
  .endif
ENDM

stack_frame_OFF proc	
  nfLocal MyV1, MyV2, MyV3, MyV4, MyV5, MyV6
  mov MyV1, eax
  add eax, eax
  mov MyV2, eax
  mov MyV3, 1234h
  .if eax==123456
	nfPush eax
	nfPush ecx
	nfPush eax
	nfPush ecx
	print chr$(13, 10, "Frame OFF: ")
	mov ecx, MyV2			; does ecx now contain the value of MyV2?
	print str$(ecx), " = "	; OK because ecx = [esp+X] and esp is unchanged
	print str$(MyV2)		; wrong variable because for printing, we need to push [eSp+X], i.e. esp is changed
	nfPop ecx
	nfPop eax
	nfPop ecx
	nfPop eax
  .endif
  mov MyV4, 5678h
  mov MyV5, 5555h
  mov MyV6, 6666h
  nfRet
stack_frame_OFF endp
stack_frame_OFF_END:

stack_frame_ON proc
LOCAL Myv1, Myv2, Myv3, Myv4, Myv5, Myv6
  mov Myv1, eax
  add eax, eax
  mov Myv2, eax
  mov Myv3, 1234h
  .if eax==123456
	Push eax
	Push ecx
	Push eax
	Push ecx
	print chr$(13, 10, "Frame  ON: ")
	mov ecx, Myv2
	print str$(ecx), " = "	; OK because ecx = [ebp+X]
	print str$(Myv2)		; right Myvariable because we are pushing [eBp+X]
	Pop ecx
	Pop eax
	Pop ecx
	Pop eax
  .endif
  mov Myv4, 5678h
  mov Myv5, 5555h
  mov Myv6, 6666h
  ret
stack_frame_ON endp
stack_frame_ON_END:

end start

RichMasm options:
OPT_Wait	0
OPT_Tmp2Asm	1
